Bug 3250 - rare ConcurrentModificationException during subscription
: rare ConcurrentModificationException during subscription
Status: RESOLVED FIXED
: Java WS Core
globus_wsrf_core
: 4.0.0
: PC Windows XP
: P3 normal
: ---
Assigned To:
:
:
:
:
  Show dependency treegraph
 
Reported: 2005-05-01 23:56 by
Modified: 2005-05-09 01:31 (History)


Attachments
Full stack trace (9.09 KB, text/plain)
2005-05-01 23:57, Jarek Gawor
Details


Note

You need to log in before you can comment on or make changes to this bug.


Description From 2005-05-01 23:56:22
Failed to store resource; nested exception is:   
java.util.ConcurrentModificationException
java.util.ConcurrentModificationException
 at java.util.AbstractList$Itr.checkForComodification(AbstractList.java:440)
 at java.util.AbstractList$Itr.next(AbstractList.java:413)
 at 
org.globus.wsrf.utils.SubscriptionPersistenceUtils.addSubscriptionListenersToTab
le(SubscriptionPersistenceUtils.java:94)
 at org.globus.wsrf.utils.SubscriptionPersistenceUtils.getListenerToTopicsTable
(SubscriptionPersistenceUtils.java:71)
 at 
org.globus.wsrf.utils.SubscriptionPersistenceUtils.storeSubscriptionListeners
(SubscriptionPersistenceUtils.java:45)
 at org.globus.wsrf.impl.notification.NotificationTestResource.store
(NotificationTestResource.java:189)
 at org.globus.wsrf.impl.notification.SubscribeHelper.subscribe
(SubscribeHelper.java:426)
 at org.globus.wsrf.impl.notification.SubscribeProvider.subscribe
(SubscribeProvider.java:97)
 at org.apache.axis.providers.java.RPCProvider.invokeMethod
(RPCProvider.java:384)
------- Comment #1 From 2005-05-01 23:57:05 -------
Created an attachment (id=600) [details]
Full stack trace
------- Comment #2 From 2005-05-02 08:44:03 -------
Hmm, looks like the stuff in persistent subscription utils is not sufficiently
synchronized wrt both 
adding new topics and adding/removing subscription listeners. I will take a
look at this.

/Sam
------- Comment #3 From 2005-05-02 13:09:34 -------
I committed a fix (hopefully) that should take care of Topic listener 
concurency issues. However, there still might be an issue with concurency of 
adding/removing/iterating over Topics. I don't think we have real tests for it.
------- Comment #4 From 2005-05-09 01:31:29 -------
Since the ConcurrentModificationException fix appears to be working, I'm 
closing the bug. The Topic concurrency issues can be tracked in another bug.